
C ?? flags
C Program	D H _ M A N A G E R	- JW, Reading, Nov.93
C                                         updated for multiple charge sets,
C					  Apr.94
C This is a derivative of the 1994 fd_manager - here we just do simple
C DH calculations rather than the fdcalc looping.  Output the same as
C fd_manager - suitable for pk_calc.
C An initial input file of individual groups is translated into a set of
C arrays that will be filled up with potentials/energies - we do not follow
C fd_manager looping in/out - since we can do it all in one run (without
C needing to wait for fdcalc runs).
C There will also be an outer loop on the various charge sets representing
C various (partially) charges forms of the ionisable groups.

C Updated Jan 2000 with temperature - but currently no T/diel look-up.

	REAL		gps_sum (355,4)
	CHARACTER*4	gps_type (355), rgps (355)
	INTEGER		igps (355,4), igps_nres (355)
	CHARACTER*1	cgps (355)
	CHARACTER*80	mol_label
	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			xyz1 (3), xyz2 (3), Vf (355,3)
	INTEGER		qopind (355,10,4), nq_gps (4),
     1			ind_xyz (355,10,4)
	CHARACTER*80	this_line
	LOGICAL*1	done (355,2,3,4)
	LOGICAL		Q_set (5), extra_runs, incl_ion
	CHARACTER*80	Q_file (5), curr_Q_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60)

	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/various/	extra_runs, i_gp_here, pH
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_todo
	COMMON	/ctr_params/	diel_eff, incl_ion, conc_ion, temp_K

1300	FORMAT (A80)
2000	FORMAT (' dh_manager - done for ',I3,
     1' ionisables and ',I1,' non-fixed charge sets')

9300	FORMAT ('0','*** we still have Q_set true flags to go')
9400	FORMAT ('0','*** mix-up in getting next i_Q_here')

C Setup.

C Initialise the Q_file array.

C ??	DO 130 l = 1, 5
C ??	  DO 130 m = 1, 60
C ??	    Q_file (l,m) = ' '
C ??130	CONTINUE

	CALL	ctr_setup
	CALL	read_groups
	CALL	setup
	CALL	dh_calc (xyz1,xyz2,1, value)

C Outer loop is over i_Q_todo, which is n_Q_sets-1. Inner loop over ionisables.

	DO 600 i_Q_here		= 1, i_Q_todo

	  IF (.NOT. Q_set (i_Q_here+1)) GOTO 940
	  curr_Q_file		= Q_file (i_Q_here+1)
C ??	  DO 260 m		= 1, 60
C ??	    curr_Q_file (m)	= Q_file (i_Q_here+1,m)
C ??260	  CONTINUE						! End m

	  DO 500 i_gp_here	= 1, n_gps
	    CALL	process
	    DO 300 m				= 1, 2
	      DO 300 n				= 1, 3
	        done (i_gp_here,m,n,i_Q_here)	= .TRUE.
300	    CONTINUE						! End m,n

500	  CONTINUE						! End i_gp_here

600	CONTINUE						! End i_Q_here

C Just check that we didn't think there were any more ionisable charge sets
C to work on after this.

	IF (i_Q_todo .LT. 4) THEN
	  DO 620 jj	= i_Q_todo+2, 5
	    IF (Q_set (jj)) GOTO 930
620	  CONTINUE						! End jj
	END IF

C We are done then - write it all out - for pk_calc(_new) to use.

	WRITE (2,*)
	WRITE (2,2000) n_gps, i_Q_todo
	CALL	write_data
	CLOSE (UNIT=2)
	CALL	EXIT

930	WRITE (6,9300)
	CALL	EXIT

940	WRITE (6,9400)
	CALL	EXIT
	END


	SUBROUTINE	ctr_setup
C	**********	*********

C Get the parameters.

	LOGICAL		incl_ion, extra_runs
	LOGICAL		Q_set (5)
	CHARACTER*80	Q_file (5), curr_Q_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60)
	CHARACTER*8	check
	REAL		gps_sum (355,4)
	CHARACTER*4	gps_type (355), rgps (355)
	CHARACTER*1	cgps (355)
	INTEGER		igps (355,4), igps_nres (355), nq_gps (4)
	CHARACTER*80	mol_label, line

	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/various/	extra_runs, i_gp_here, pH
	COMMON	/ctr_params/	diel_eff, incl_ion, conc_ion, temp_K
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_todo

1040	FORMAT (A80)
1100	FORMAT (A8)
C??1200	FORMAT (Q,60A1)
9000	FORMAT ('0','*** error reading from com file in ctr_setup')
9100	FORMAT ('0','*** We must have a fixed charge set matey')
9200	FORMAT ('0','*** Would like a fxed Q set + one other')
9300	FORMAT ('0','*** We have updated for temp_K i/p - provide')

	OPEN (UNIT=1, NAME='dh_manager.in', TYPE='OLD')

C Read the molecule/run label.

	READ (1,1040) mol_label

C Read through the various charge files.  The first one gives the fixed charges
C that are used for all ionisable group calculations - they remain constant -
C it is necessary.  None of the others is compulsory - but list_energy and
C pK_calc will tell us if we don't have the right material for the calculation
C we want - e.g. charged partially charge ionisable groups will want at least
C one neutral partially charged form to difference with.  The 2 neutral forms
C will allow us to put in the double forms of aspH,gluH,his, and arg?
C	Q_set 1    -    fixed		fixed dipolar charges for all runs
C	      2    -	chr_unit	unit charges from +/- (1.0 or 2*0.5)
C	      3    -	chr_prtl	unit charges from distributed prtl Q's
C	      4    -    neutral1	zero charge  from distributed prtl Q's
C             5    -	neutral2	zero charge  from distributed prtl Q's

	n_Q_sets		= 0
	READ (1,1100) check
	IF (check .NE. 'charges ') GOTO 900
	READ (1,1100) check
	IF (check .NE. 'fixed   ') GOTO 900
	READ (1,*) Q_set (1)
	IF (Q_set (1)) THEN
	  n_Q_sets		= n_Q_sets + 1
	  READ (1,1040) line
	  CALL	get_filename (line, Q_file (1))
C ??	  READ (1,1200) nc, (Q_file (1,ic), ic=1,nc)
	ELSE
	  GOTO 910
	END IF
	READ (1,1100) check
	IF (check .NE. 'chr_unit') GOTO 900
	READ (1,*) Q_set (2)
	IF (Q_set (2)) THEN
	  n_Q_sets		= n_Q_sets + 1
	  READ (1,1040) line
	  CALL	get_filename (line, Q_file (2))
C ??	  READ (1,1200) nc, (Q_file (2,ic), ic=1,nc)
	END IF
	READ (1,1100) check
	IF (check .NE. 'chr_prtl') GOTO 900
	READ (1,*) Q_set (3)
	IF (Q_set (3)) THEN
	  n_Q_sets		= n_Q_sets + 1
	  READ (1,1040) line
	  CALL	get_filename (line, Q_file (3))
C ??	  READ (1,1200) nc, (Q_file (3,ic), ic=1,nc)
	END IF
	READ (1,1100) check
	IF (check .NE. 'neutral1') GOTO 900
	READ (1,*) Q_set (4)
	IF (Q_set (4)) THEN
	  n_Q_sets		= n_Q_sets + 1
	  READ (1,1040) line
	  CALL	get_filename (line, Q_file (4))
C ??	  READ (1,1200) nc, (Q_file (4,ic), ic=1,nc)
	END IF
	READ (1,1100) check
	IF (check .NE. 'neutral2') GOTO 900
	READ (1,*) Q_set (5)
	IF (Q_set (5)) THEN
	  n_Q_sets		= n_Q_sets + 1
	  READ (1,1040) line
	  CALL	get_filename (line, Q_file (5))
C ??	  READ (1,1200) nc, (Q_file (5,ic), ic=1,nc)
	END IF
	IF (n_Q_sets .LT. 2) GOTO 920
	i_Q_todo	= n_Q_sets - 1

C Modified Jan 2000 to also read the temperature - at present we must
C check that we have the right diel for the temp outside of the program.

	READ (1,1100) check
	IF (check .NE. 'dielvals') GOTO 900
	READ (1,*,ERR=930) diel_eff, temp_K

	READ (1,1100) check
	IF (check .NE. 'pH      ') GOTO 900
	READ (1,*) pH
	READ (1,1100) check
	IF (check .NE. 'inclions') GOTO 900
	READ (1,*) incl_ion, conc_ion

C ?? carry extra_runs=F - fd hangover - since we will need it for o/p, and
C ?? to make sure that pk_calc doesn't try to average.

	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT

930	WRITE (6,9300)
	CALL	EXIT
	END


	SUBROUTINE	read_groups
C	**********	***********

C Read in the indidual groups to calculate on, from fd_manager.in file.

	REAL		gps_sum (355,4)
	CHARACTER*4	gps_type (355), rgps (355)
	INTEGER		igps (355,4), igps_nres (355), nq_gps (4)
	CHARACTER*1	cgps (355)
	CHARACTER*8	check
	CHARACTER*80	mol_label

	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps

1100	FORMAT (A8)
C ??1200	FORMAT (A4,1X,I5,1X,A4)
1200	FORMAT (A4,1X,A1,I4,1X,A4)

9000	FORMAT ('0','n_gps is oub')
9100	FORMAT ('0','*** GROUPS id not found')

C Get the number of individual groups.  And the nres, res and ionisable
C group type, which is used in making the individual charge files.
C Also initialise the various charge set, charge bit counters.

	READ (1,1100) check
	IF (check .NE. 'groups  ') GOTO 910
	READ (1,*) n_gps
	IF (n_gps.LT.1 .OR. n_gps.GT.355) GOTO 900
	DO 300 i	= 1, n_gps
	  READ (1,1200)	rgps(i), cgps(i), igps_nres(i), gps_type(i)
	  DO 280 j	= 1,4
	    igps (i,j)	= 0
280	  CONTINUE						! End j
300	CONTINUE						! End i
	CLOSE (UNIT=1)
	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT
	END


	SUBROUTINE	setup
C	**********	*****

C Setup the output file, dh_manager.out.  At present we'll have this as
C a sequential file, unformatted, with complete read, and then overwriting
C must of it every time - what about D.A.??

	REAL		se (355,2,3,10,4),
     1			char (355,10,4), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			pKint (355), gps_sum (355,4), Vf (355,3)
	INTEGER		igps (355,4), igps_nres (355),
     1			qopind (355,10,4), nq_gps (4),
     2			ind_xyz (355,10,4)
	CHARACTER*1	cgps (355)
	LOGICAL*1	done (355,2,3,4)
	CHARACTER*80	mol_label
	CHARACTER*4	gps_type (355), rgps (355)

	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf

1100	FORMAT(' ',30X,'DH_MANAGER.INF')
1150	FORMAT (' ',12X,'ALL SPECIFIED IONISABLE MUST HAVE UNIQUE
     1 RESIDUE NUMBERS')
1200	FORMAT (' ',A80)
1300	FORMAT (' ','Number of individual groups =  ',I3)
1320	FORMAT (' ','ALL groups not individually specified, but present
     1 in .QOP file,')
1330	FORMAT (' ','WILL be treated as fixed charges and lumped
     1 into the prtl Q sum')
1340	FORMAT (' ','IT SHOULD be possible to have "add on" dh_manager
     1 runs')
1350	FORMAT (' ','IF we specify ALL individual gps from the start')

	OPEN (UNIT=2, NAME='dh_manager.inf', TYPE='NEW')
	WRITE (2,1100)
	WRITE (2,*)
	WRITE (2,1150)
	WRITE (2,*)
	WRITE (2,1200) mol_label
	WRITE (2,1300) n_gps
	WRITE (2,1320)
	WRITE (2,1330)
	WRITE (2,1340)
	WRITE (2,1350)
	WRITE (2,*)

C Read in the overall ESCALC.QOP file to identify gps, and put ALL
C the rest into the fixed charges arrays.

	CALL	read_escalc

C Set the gp flags to all undone.

	DO 300 i		= 1, n_gps
	  DO 300 j		= 1, 2
	    DO 300 k		= 1, 3
	      DO 300 m		= 1, 4
		done (i,j,k,m)	= .FALSE.
300	CONTINUE						! End i

C Initialise the gpij array to zero everywhere, so that we know when we've
C been tangoed (reproducibly).

	DO 400 i			= 1, 4
	  DO 400 j			= 1, 10
	    DO 400 k			= 1, 355
	      DO 400 m			= 1, 3
		DO 400 n		= 1, 355
		  gpij (n,m,k,j,i)	= 0.
400	CONTINUE						! End 5

	RETURN
	END


	SUBROUTINE	read_escalc
C	**********	***********

C This routine reads in charge files as specified in the /charges_in/
C common. Set up the gps and fixd charge arrays as we go along.  Only those
C ionisable gps specified in "dh_manager.in" are carried separate from
C the fixed charges.  Ionisable groups in the first (fixed Q) .qop are set at
C their std magnitude values ADJUSTED by the input pH (so that e.g. tyr's
C are not put in at -1.00 if neutral pH is given).

C OCT.2001 - also we are NOW putting all 'full'.qop charges whether selected
C OCT.2001 - from 'dh_manager.in' or not.  If not selected (.in) then we will
C OCT.2001 - take just the 'full' file charge (not partials) at i/p pH.
C OCT.2001 - putting in chain id all the way through.

C ?? Note that we assume any matches to nres/res of i_gp that are ionisable
C ?? are part of i_gp - could be trouble with this, (atyp's not used curr.)

C qop variables --------------------------------------------------
	REAL		qr_buf (7)
	CHARACTER*4	qa4_buf (3)
	INTEGER		qi_buf (3)
	LOGICAL		ql_buf (2)
	INTEGER		which_VdW_es
	LOGICAL		macinc, itrate, pkq
C grp i/p variables ----------------------------------------------
	REAL		gps_sum (355,4)
	CHARACTER*4	rgps (355)
	INTEGER		igps (355,4), igps_nres (355)
	CHARACTER*80	mol_label

C igps_nres is nres.  igps (i,x) is counter of the Q bits found for gps i as
C we read in the escalc.qop file x.  gps_sum (i,x) is a sum check on the
C amount of charge read in - we'll check it against 0/+-1.
C grp store variables --------------------------------------------
	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4)
	INTEGER		qopind (355,10,4), nq_gps (4),
     1			ind_xyz (355,10,4)
	LOGICAL*1	done (355,2,3,4)

C ind_xyz (igp,i_Q,i bit of gp) - the index for this bit in the gpij array
C done (igp/i protein or alone run/i foc cen run/i Q set)	- run done?
C fix  (igp/i protein or alone run/i foc cen run/i Q set)	- fixd Qs sum
C se   (...................................../i bit of gp/iQset)- se potl
C char (igp/i bit of gp/i Q set)				- Q of bit
C xyz  (igp/i bit of gp/1-3/i Q set)				- xyz of bit
C gpij (igp/i foc cen run/j gp/bit ind_here/iQset)-(only prt run)-ptls -jbits
C	where the "bit ind_here" index comes from ind_xyz
C pKint (igp)							- pKint
C qopind (igp/i bit of gp/i Q set)				- iq in qop

C fix store variables --------------------------------------------
	REAL		fix_xyz (3,10000), fix_q (10000)
	CHARACTER*4	fix_res (10000), fix_atyp (10000)
	INTEGER		fix_nres (10000)
	CHARACTER*1	fix_chain (10000)

C fix arrays are clear - nres/res allow match up with aa of a gp.
C ----------------------------------------------------------------
	REAL		xyz_here (3), xyz_test (3), Vf (355,3)
	INTEGER		ind_curr (355)
	CHARACTER*4	gps_type (355), res_here
	CHARACTER*1	cgps (355), chain_here, qc_buf
	LOGICAL		extra_runs
	LOGICAL		Q_set (5), chk_igps (355)
	CHARACTER*80	Q_file (5), curr_Q_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60)

	COMMON	/various/	extra_runs, i_gp_here, pH
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/fix_data/	nq_fix,fix_xyz, fix_q, fix_nres,
     1				fix_res, fix_atyp, fix_chain
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_todo

2000	FORMAT (' ','i/p Q set ',I1,' absolute Q index ',I1,' with
     1 ',I4,' ionisable Q atoms found')
2200	FORMAT (' ','i/p fixed charge set gave ',I5,
     1 'fixed charge atoms with charge sum ',F6.1)
2205	FORMAT (/,'*** We will also fix those ionisables in "full"
     1 charges but not ".in" ***')
2210	FORMAT (' ','*** And after that we get ',I5,
     1 'fixed charge atoms with charge sum ',F6.1,' ***',/)
2400	FORMAT ('0',78('-'))
C??2600	FORMAT (' ','Group ',I3,2X,A4,2X,I5,'gpij indices used = ',I2)
2600	FORMAT (' ','Group ',I3,2X,A4,2X,A1,I4,'gpij indices = ',I2)

9100	FORMAT ('0','*** too many fixed charges in read_escalc')
9300	FORMAT ('0','*** charged bist mismatch2 in read_escalc ',
     1 A1,1X,I4,1X,A4)
9400	FORMAT ('0','*** Aha, i_Q_found .ne. n_Q_sets')
9500	FORMAT ('0','*** ind_here (for ind_xyz) is oub')

C Our check that the non-fixed charge sets are giving the same gps is firstly
C to see that each gp from .in has been hit by each set, and secondly to make
C sure that we get 0,+/-1 summed charged values over a group.

	nq_fix			= 0
	q_fix_sum		= 0.
	i_Q_found		= 0

C We just have a single counter over the (non-fixed) charge sets of bit
C indices for gpij - this is cumulative - only one gpij slot per atom.

	DO 120 m		= 1, n_gps
	  ind_curr (m)		= 0
120	CONTINUE						! End m

C The first charge set will be the fixed charges.

	DO 600 i_Q_set		= 1, 5
	  nq_gps_here		= 0
	  DO 140 m		= 1, n_gps
	    chk_igps (m)	= .FALSE.
140	  CONTINUE						! End n

	  IF (Q_set (i_Q_set)) THEN

	    i_Q_found		= i_Q_found + 1
	    curr_Q_file		= Q_file (i_Q_set)
C ??	    DO 160 m		= 1, 60
C ??	      curr_Q_file (m)	= Q_file (i_Q_set,m)
C ??160	    CONTINUE						! End m
	    OPEN (UNIT=3, NAME=curr_Q_file, TYPE='OLD',
     1	          FORM='UNFORMATTED')
	    READ (3) nfil
	    DO 200 ifil		= 1, nfil
	      READ (3)						! pdbfil
	      READ (3)						! qfil
200	    CONTINUE						! ifil
	    READ (3) nq_here, macinc, itrate, i_qset, which_VdW_es, ncal
	    DO 300 iq		= 1, nq_here

	      READ (3) (qr_buf (m), m=1,7), (qa4_buf (m), m=1,3),
     1		       (qi_buf (m), m=1,3), (ql_buf (m), m=1,2),
     2			qc_buf

	      IF (i_Q_set .EQ. 1) THEN
		nq_fix			= nq_fix + 1
		IF (nq_fix .GT. 10000) GOTO 910
		fix_xyz (1,nq_fix)	= qr_buf (1)
		fix_xyz (2,nq_fix)	= qr_buf (2)
		fix_xyz (3,nq_fix)	= qr_buf (3)
		IF (ql_buf (1)) THEN
		  qmag			= qr_buf (4)
		  pkq			= ql_buf (1)
		  pk			= qr_buf (5)
		  CALL	q_calc (qmag, pkq, pk, pH, q_here)
		  fix_q (nq_fix)	= q_here
C !! - write to .inf the ionisable fixed value - an extra check for us
		ELSE
		  fix_q (nq_fix)	= qr_buf (4)
		END IF
		q_fix_sum		= q_fix_sum + fix_q (nq_fix)
		fix_res (nq_fix)	= qa4_buf (1)
		fix_atyp (nq_fix)	= qa4_buf (2)
		fix_nres (nq_fix)	= qi_buf (1)
		fix_chain (nq_fix)	= qc_buf

	      ELSE
		IF (ql_buf (1)) THEN

		  res_here		= qa4_buf (1)
		  nres_here		= qi_buf (1)
		  chain_here		= qc_buf
		  DO 240 ig		= 1, n_gps

C !! Note that we are relaxing the res check here, to avoid eg GLU1 clashing
C !! with GLU.  We could reinstate this with some char* work, if needed.
C OCT.2001 We are introducing the chain id throughout (from escalc) and
C OCT.2001 it must match between '.in' selected gps and escalc '.qop'

		    IF ( (nres_here .EQ. igps_nres (ig)) .AND.
     1			 (chain_here .EQ. cgps (ig)) ) THEN	! gps charge

C !!		    IF ((res_here .EQ. rgps (ig)) .AND.
C !! 1			(nres_here .EQ. igps_nres (ig))) THEN	! gps charge

C This is the ind_xyz assignment - first check if we are sitting on any
C previously indexed locations - if so, use the same index - if not add
C a new one.

		      DO 205 n			= 1, 3
			xyz_here (n)		= qr_buf (n)
205		      CONTINUE					! End n
		      DO 220 i_Q_test		= 2, i_Q_set
			IF (.NOT. Q_set (i_Q_test)) GOTO 220
			nb_test			= igps (ig,i_Q_test-1)
			IF (nb_test .GT. 0) THEN
			  DO 215 ib_test	= 1, nb_test
			    DO 210 n		= 1, 3
			      xyz_test (n)	=
     1					xyz (ig,ib_test,n,i_Q_test-1)
210			    CONTINUE				! End n
			    dist=SQRT( (xyz_here(1)-xyz_test(1))**2 +
     1				       (xyz_here(2)-xyz_test(2))**2 +
     2				       (xyz_here(3)-xyz_test(3))**2 )
			    IF (dist .LE. 0.01) THEN
			      ind_here=ind_xyz (ig,ib_test,i_Q_test-1)
			      IF (ind_here.LT.1.OR.ind_here.GT.10)
     1							GOTO 950
			      GOTO 230
			    END IF
215			  CONTINUE				! End ib_test
			END IF
220		      CONTINUE					! End i_Q_test

		      ind_curr (ig)	= ind_curr (ig) + 1
		      ind_here		= ind_curr (ig)
		      IF (ind_here.LT.1.OR.ind_here.GT.10) GOTO 950

230		      CONTINUE

		      igps (ig,i_Q_set-1) = igps (ig,i_Q_set-1) + 1
		      gps_sum(ig,i_Q_set-1) = gps_sum(ig,i_Q_set-1) +
     1					      qr_buf (4)
		      nq_gps_here	= nq_gps_here + 1
		      ib		= igps (ig,i_Q_set-1)
		      ind_xyz (ig,ib,i_Q_set-1) = ind_here

		      xyz (ig,ib,1,i_Q_set-1)	= qr_buf (1)
		      xyz (ig,ib,2,i_Q_set-1)	= qr_buf (2)
		      xyz (ig,ib,3,i_Q_set-1)	= qr_buf (3)

		      char (ig,ib,i_Q_set-1)	= qr_buf (4)
C ?? now this pKa we pick up is labelled pKint - IS IT OK? - CHECK
C ?? - it would save us reading through qop to pKcur
		      IF (i_Q_set .EQ. 2) THEN
			pKint (ig)		= qr_buf (5)
		      END IF
		      qopind (ig,ib,i_Q_set-1)	= iq
		      chk_igps (ig)		= .TRUE.
		      GOTO 300
		    END IF
240		  CONTINUE					! End ig

C OCT.2001 - this is where we get to for an ionisable that is not in '.in'.
C OCT.2001 - we only process it for the 'full' charge file (i_Q_set=2).

		IF (i_Q_set .EQ. 2) THEN
		    nq_fix		= nq_fix + 1
		    IF (nq_fix .GT. 10000) GOTO 910
		    fix_xyz (1,nq_fix)	= qr_buf (1)
		    fix_xyz (2,nq_fix)	= qr_buf (2)
		    fix_xyz (3,nq_fix)	= qr_buf (3)
C ?? - we know it is ionisable		IF (ql_buf (1)) THEN
		    qmag		= qr_buf (4)
		    pkq			= ql_buf (1)
		    pk			= qr_buf (5)
		    CALL	q_calc (qmag, pkq, pk, pH, q_here)
		    fix_q (nq_fix)	= q_here
C !! - write to .inf the ionisable fixed value - an extra check for us
C ??		    ELSE
C ??		    fix_q (nq_fix)	= qr_buf (4)
C ??		    END IF
		    q_fix_sum		= q_fix_sum + fix_q (nq_fix)
		    fix_res (nq_fix)	= qa4_buf (1)
		    fix_atyp (nq_fix)	= qa4_buf (2)
		    fix_nres (nq_fix)	= qi_buf (1)
		    fix_chain (nq_fix)	= qc_buf
		  END IF					! i_Q_set 2 ?

C OCT.2001 - end of the insert.

		END IF						! If ionisable
	      END IF						! i_Q_set 1 ?
300	    CONTINUE						! End iq

C !! - curtly - what to do next?

	    IF (i_Q_set .EQ. 1) THEN
	      WRITE (2,2200) nq_fix, q_fix_sum
	    ELSE
	      IF (i_Q_set .EQ. 2) THEN
		WRITE (2,2205)
		WRITE (2,2210) nq_fix, q_fix_sum
	      END IF
	      DO 340 ig	= 1, n_gps
	        IF (.NOT. chk_igps (ig)) GOTO 930
	        IF ((ABS (gps_sum (ig,i_Q_set-1)+1.0).GT.0.001) .AND.
     1	          (ABS (gps_sum (ig,i_Q_set-1)).GT.0.001) .AND.
     2	          (ABS (gps_sum (ig,i_Q_set-1)-1.0).GT.0.001) ) THEN
		  GOTO 930
	        END IF
340	      CONTINUE						! End ig
	      WRITE (2,2000) i_Q_found, i_Q_set, nq_gps_here
	      nq_gps (i_Q_set-1)	= nq_gps_here
	    END IF

	    CLOSE (UNIT=3)
	  END IF

600	CONTINUE						! End i_Q_set

	WRITE (2,2400)
	DO 700 ig	= 1, n_gps
	 WRITE (2,2600) ig,rgps(ig),cgps(ig),igps_nres(ig),ind_curr(ig)
700	CONTINUE						! End ig
	WRITE (2,2400)

	IF (i_Q_found .NE. n_Q_sets) GOTO 940
C !! - curtly - o/p info on number of charge sets found

	RETURN

910	WRITE (6,9100)
	CALL	EXIT

930	WRITE (6,9300) cgps(ig), igps_nres(ig), rgps(ig)
	CALL	EXIT

940	WRITE (6,9400)
	CALL	EXIT

950	WRITE (6,9500)
	CALL	EXIT
	END


	SUBROUTINE	q_calc (qmag, pkq, pk, pH, q_here)
C	**********	******

C With (pk,ph) adjustment, fraction of charged/uncharged = 10**ff*(ph-pk),
C where ff=-1 for a base, ff=+1 for an acid.

	LOGICAL		pkq

9000	FORMAT ('0','*** ERROR *** problem with q_here in q_calc')

	IF (pkq) THEN
	  ff		= 1.0
	  IF (qmag .GT. 0.) ff = -1.0
	  exp		= ff * (pH-pk)
	  IF (exp .GT.  60.) exp =  60.
	  IF (exp .LT. -60.) exp = -60.
	  fracq		= 10. ** exp
	  frac		= 1. / (1. + 1./fracq)
	  q_here	= frac * qmag
	ELSE
	  q_here	= qmag
	END IF

	IF (ABS (q_here) .GT. ABS (qmag)) GOTO 900
	IF (q_here * qmag .LT. 0.)	  GOTO 900
	RETURN

900	WRITE (6,9000)
	CALL	EXIT
	END


	SUBROUTINE	write_data
C	**********	**********

C Write out the complete dh_manager.out file.

	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			fix_xyz (3,10000), fix_q (10000),
     4			gps_sum (355,4), Vf (355,3)
	CHARACTER*4	fix_res (10000), fix_atyp (10000),
     1			rgps (355)
	INTEGER		qopind (355,10,4), fix_nres (10000),
     1			igps (355,4), igps_nres (355), nq_gps (4),
     2			ind_xyz (355,10,4)
	CHARACTER*1	cgps (355), fix_chain (10000)
	CHARACTER*80	mol_label
	LOGICAL*1	done (355,2,3,4)
	CHARACTER*4	gps_type (355)
	LOGICAL		extra_runs
	LOGICAL		Q_set (5)
	CHARACTER*80	Q_file (5), curr_Q_file, dummy (5)
C ??	BYTE		Q_file (5,60), curr_Q_file (60), dummy (5,60)

	COMMON	/various/	extra_runs, i_gp_here, pH
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/fix_data/	nq_fix,fix_xyz, fix_q, fix_nres,
     1				fix_res, fix_atyp, fix_chain
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_todo

C ?? set dummy params - hangovers from fd_manager/not used by p_calc.

	i_Q_done	= 0
	extra_runs	= .FALSE.

C ??	DO 130 l = 1, 5
C ??	  DO 130 m = 1, 60
C ??	    dummy (l,m) = ' '
C ??130	CONTINUE

C ?? - is this all variable record lengths?
	OPEN (UNIT=1, NAME='dh_manager.out', TYPE='NEW',
     1	      FORM='UNFORMATTED')

	WRITE (1) mol_label
	WRITE (1) i_gp_here, i_Q_here
	WRITE (1) n_Q_sets, i_Q_done, i_Q_todo, (Q_set (j), j=1,5),
     1		  (Q_file (j), j=1,5)
	WRITE (1) (dummy (j), j=1,5)
	WRITE (1) n_gps, (nq_gps (m), m=1,4), extra_runs
	WRITE (1) ((igps (i,j), j=1,4), i=1,n_gps),
     1		  (igps_nres (i), i=1,n_gps),
     2		  (cgps (i), i=1,n_gps)
	WRITE (1) (((ind_xyz (i,j,k), k=1,4), j=1,10), i=1,n_gps)
	WRITE (1) (rgps(i),i=1,n_gps),((gps_sum(i,j),j=1,4),i=1,n_gps)
	WRITE (1) (gps_type (i), i=1,n_gps)
	WRITE (1) ((((done (i,j,k,m), m=1,4), k=1,3), j=1,2),
     1		      i=1,n_gps)
	WRITE (1) (((((se (i,j,k,l,m), m=1,4), l=1,10), k=1,3),
     1		       j=1,2), i=1,n_gps)
	WRITE (1) (((char (i,j,m), m=1,4), j=1,10), i=1,n_gps)
	WRITE (1) ((((xyz (i,j,k,m), m=1,4), k=1,3),j=1,10),i=1,n_gps)
	WRITE (1) ((((fix (i,j,k,m), m=1,4), k=1,3), j=1,2),i=1,n_gps)
	WRITE(1) (((((gpij(i,j,k,l,m), m=1,4), l=1,10), k=1,n_gps),
     1		     j=1,3), i=1,n_gps)
	WRITE (1) (pKint (i), i=1,n_gps)
	WRITE (1) ((Vf (i,j), j=1,3), i=1,n_gps)
	WRITE (1) (((qopind (i,j,m), m=1,4), j=1,10), i=1,n_gps)
	WRITE (1) nq_fix
	DO 200 i	= 1, nq_fix
	  WRITE (1) (fix_xyz (j,i), j=1,3), fix_q (i), fix_res (i),
     1		     fix_atyp (i), fix_nres (i), fix_chain (i)
200	CONTINUE						! End i

	CLOSE (UNIT=1)

	RETURN
	END


	SUBROUTINE	process
C	**********	*******

C Do the required interpolations and summations.

	LOGICAL		extra_runs, incl_ion

	COMMON	/various/	extra_runs, i_gp_here, pH
	COMMON	/ctr_params/	diel_eff, incl_ion, conc_ion, temp_K

C Loop on the Protein and Isolated aa runs (i_sys).

	DO 600 i_sys			= 1, 2
	  i_sys_here			= i_sys
	  CALL	energise (i_sys_here)
600	CONTINUE						! End i_sys

	RETURN
	END


	SUBROUTINE	energise (i_sys)
C	**********	********

C Do all the processing for this (i_sys)

	REAL		se (355,2,3,10,4), char (355,10,4),
     1			pKint (355), xyz (355,10,3,4),
     2			fix (355,2,3,4), gpij (355,3,355,10,4),
     3			fix_xyz (3,10000), fix_q (10000),
     4			gps_sum (355,4), xyz_here (3),
     5			xyz_ibit (3), xyz_jbit (3), Vf (355,3)
	CHARACTER*4	fix_res (10000), fix_atyp (10000),
     1			rgps (355)
	INTEGER		qopind (355,10,4), fix_nres (10000),
     1			igps (355,4), igps_nres (355), nq_gps (4),
     2			ind_xyz (355,10,4)
	CHARACTER*4	gps_type (355), type_gp, res_here
	CHARACTER*1	cgps (355), fix_chain (10000), chain_here
	CHARACTER*80	mol_label
	LOGICAL		extra_runs, incl_ion
	LOGICAL*1	done (355,2,3,4)
	LOGICAL		Q_set (5)
	CHARACTER*80	Q_file (5), curr_Q_file
C ??	BYTE		Q_file (5,60), curr_Q_file (60)

	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				cgps
	COMMON	/gps_data/	done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/fix_data/	nq_fix,fix_xyz, fix_q, fix_nres,
     1				fix_res, fix_atyp, fix_chain
	COMMON	/charges_in/	n_Q_sets, Q_set, Q_file, curr_Q_file,
     1				i_Q_here, i_Q_todo
	COMMON	/various/	extra_runs, i_gp_here, pH
	COMMON	/ctr_params/	diel_eff, incl_ion, conc_ion, temp_K

1200	FORMAT (' i_sys,i_Q,    nq_fix = ',3I5)
1400	FORMAT ('       i_Q,j_Q,nq_gps = ',6X,3I5)

9400	FORMAT ('0','*** unidentified type_gp')
9500	FORMAT ('0','*** the ind_here bit index is oub')
9600	FORMAT ('0','*** overwriting an unequal slot in gpij')

	nres_here		= igps_nres (i_gp_here)
	res_here		= rgps (i_gp_here)
	chain_here		= cgps (i_gp_here)
	type_gp			= gps_type (i_gp_here)

C For the self-energies we process the same for i_sys 1 and 2, and of course
C for the DH calculation they are ALL ZERO !! - so we don't need xyz.
C ?? - use the 1 slot of old i_run (1-3) in se,fix,gpij arrays.

	DO 300 i_bit		= 1, igps (i_gp_here,i_Q_here)
	  se (i_gp_here,i_sys,1,i_bit,i_Q_here)	= 0.
300	CONTINUE						! End i_bit

C For the fixed charge array, we take all of them for i_sys 1, and only
C those in the same residue as i_gp_here for i_sys 2, with some
C embellishments for nter,cter and frst,last residues.
C %% Again, we are testing just on nres - we must have unique nres values.
C OCT.2001 update to test also on chain id - so do NOT need unique nres now.

	energy_fix		= 0.
	DO 400 iq		= 1, nq_fix

	  IF (i_sys .EQ. 2) THEN

C OCT.2001 - this *should* be ok:

	  IF (fix_chain (iq) .NE. chain_here) GOTO 400

	    IF      (type_gp .EQ. 'nter') THEN
	      IF (fix_nres (iq) .NE. nres_here) THEN
		IF (fix_nres (iq) .NE. nres_here+1) THEN
		  GOTO 400
		ELSE
		  IF ((fix_atyp (iq) .NE. 'C   ') .AND.
     1		      (fix_atyp (iq) .NE. 'O   ')) THEN
		    GOTO 400
		  END IF
		END IF
	      END IF
	    ELSE IF (type_gp .EQ. 'cter') THEN
	      IF (fix_nres (iq) .NE. nres_here) THEN
		IF (fix_nres (iq) .NE. nres_here-1) THEN
		  GOTO 400
		ELSE
		  IF ((fix_atyp (iq) .NE. 'N   ') .AND.
     1		      (fix_atyp (iq) .NE. 'H   ')) THEN
		    GOTO 400
		  END IF
		END IF
	      END IF
	    ELSE IF (type_gp .EQ. 'frst') THEN
	      IF (fix_nres (iq) .NE. nres_here) GOTO 400
	    ELSE IF (type_gp .EQ. 'last') THEN
	      IF (fix_nres (iq) .NE. nres_here) GOTO 400
	    ELSE IF (type_gp .EQ. 'side') THEN
	      IF (fix_nres (iq) .NE. nres_here) GOTO 400
	    ELSE
	      GOTO 940
	    END IF						! type_gp
	  END IF						! i_sys=2

	  DO 320 n		= 1, 3
	    xyz_jbit (n)	= fix_xyz (n,iq)
320	  CONTINUE						! End n

	  DO 360 i_bit		= 1, igps (i_gp_here,i_Q_here)
	    DO 340 n		= 1, 3
	      xyz_ibit (n)	= xyz (i_gp_here,i_bit,n,i_Q_here)
340	    CONTINUE						! End n
	    CALL	dh_calc (xyz_ibit,xyz_jbit,2, value)
	    energy_here		= value * fix_q (iq) *
     1				  char (i_gp_here,i_bit,i_Q_here)
	    energy_fix		= energy_fix + energy_here
360	  CONTINUE						! End i_bit

400	CONTINUE						! End iq
	fix (i_gp_here,i_sys,1,i_Q_here)	= energy_fix
	IF (i_sys.EQ.1) WRITE (2,*)
	WRITE (2,1200) i_sys,i_Q_here,nq_fix

C Get the gpij interactions just for the protein system.  Note that the
C gpij diagonal will be left unfilled.
C Note that with our indexing (via ind_xyz) into a single gpij list of
C interpolated potentials, means that we'll be assigning values more than
C once - we'll go along with this, and keep a check that the values are
C repeats of themselves.

	IF (i_sys .EQ. 1) THEN
	  DO 520 j_Q			= 1, 4
	    IF (.NOT. Q_set (j_Q+1)) GOTO 520
	    DO 500 j			= 1, n_gps
	      IF (j .EQ. i_gp_here) GOTO 500
	      DO 460 j_bit		= 1, igps (j,j_Q)
		ind_here		= ind_xyz (j,j_bit,j_Q)
		IF (ind_here.LT.1.OR.ind_here.GT.10) GOTO 950
		DO 420 n		= 1, 3
		  xyz_jbit (n)	= xyz (j,j_bit,n,j_Q)
420		CONTINUE					! End n
		val_new			= 0.
		DO 440 i_bit		= 1, igps (i_gp_here,i_Q_here)
		  DO 430 n		= 1, 3
		    xyz_ibit (n)    = xyz (i_gp_here,i_bit,n,i_Q_here)
430		  CONTINUE					! End n
		  char_ihere	    = char (i_gp_here,i_bit,i_Q_here)
		  CALL	dh_calc (xyz_ibit,xyz_jbit,2, value)
		  value	= value*char_ihere
		  val_new		= val_new + value
440		CONTINUE					! End i_bit
		val_old = gpij (i_gp_here,1,j,ind_here,i_Q_here)
		IF (ABS (val_old) .GT. 0.00001) THEN
		  IF (ABS (val_old-val_new) .GT. 0.0001) GOTO 960
		END IF
		gpij (i_gp_here,1,j,ind_here,i_Q_here) = val_new
460	      CONTINUE					! End j_bit
500	    CONTINUE						! End j
	    WRITE (2,1400) i_Q_here, j_Q, nq_gps (j_Q)
520	  CONTINUE						! End j_Q
	END IF

	RETURN

940	WRITE (6,9400)
	CALL	EXIT

950	WRITE (6,9500)
	CALL	EXIT

960	WRITE (6,9600)
	CALL	EXIT
	END


	SUBROUTINE	dh_calc (xyz_i,xyz_j,i_pass, value)
C	**********	*******

C Return a potential for ij interaction - in mV for *unit* i and j charges.

	REAL		xyz_i (3), xyz_j (3)
	LOGICAL		incl_ion


	COMMON	/ctr_params/	diel_eff, incl_ion, conc_ion, temp_K
	COMMON	/dh/		const1, debhuk, enat

	IF (i_pass .EQ. 1) THEN
	  bolt		= 1.38062 E-23
C ?? Jan 2000 temp_K	  temp		= 300.
	  diel_zer	= 8.85419 E-12
	  avagad	= 6.02217 E 23
	  elec		= 1.60219 E-19
	  enat		= 2.718282
	  pi		= 3.14159
	  log10e	= 0.4342945
	  const1	= elec / (4.*pi*diel_zer*diel_eff*1.E-10)
	  a1		= avagad*1.E3*conc_ion
	  a2		= diel_zer*diel_eff*bolt*temp_K
	  a3		= elec
	  a4		= a3 * (SQRT(2.*a1)/SQRT(a2))
	  debhuk	= a4 * 1.E-10
	ELSE
	  dist		= SQRT ( (xyz_i (1) - xyz_j (1))**2 +
     1				 (xyz_i (2) - xyz_j (2))**2 +
     2				 (xyz_i (3) - xyz_j (3))**2 )
	  value		= 1000. * (const1/dist)
	  IF (incl_ion) THEN
	    value	= value * enat**(-debhuk*dist)
	  END IF
	END IF

	RETURN
	END


	SUBROUTINE	get_filename (rec, file)
C	**********	************

C Remove leading blanks from file name.

	CHARACTER*80	rec, file
	LOGICAL		started

C Initialise the file name.

	DO 160 i	= 1, 80
	  file (i:i)	= ' '
160	CONTINUE						! End i

	n		= 1
	started		= .FALSE.
	DO 200	i	= 1, 80
	  IF (rec (i:i) .EQ. ' ') THEN
	    IF (started) GOTO 300
	  ELSE
	    started	= .TRUE.
	    file (n:n)	= rec (i:i)
	    n		= n + 1
	  END IF
200	CONTINUE						! End i

300	CONTINUE
	RETURN
	END



