
C pK_energy_scan reads through a set of pk_calc o/p files (rs and mc), to get
C the distribution of various pI, and energy measures.
C Runs through 'DHpdb_scan.list' set of pdb ids.
C May 2004.

C If we're using cellular location (LOCALISE env = 'yes'), then we use
C separate histogram slots indexed by location as well as total in slot 20.
C Otherwise, we just look at the total distn in histogram slots 20.

C March 06 update to optionally (SCF_PROCESS="yes") process scf data.
C Updated October 08 to add an interpolated pHatGmin.

	REAL		rs_en_kT(20000),mc_en_kT(51,20000),pI(3,20000),
     1			en(51,20000),G_min(20000),enN(51,20000),
     2			G_minN(20000),S(20000),SN(20000),
     3			Qratio(20000),pHminX(20000),
     4			pHmin_interp(20000),Qnet(20000,51),
     5			QnetpH7(20000)
	INTEGER		ngps(20000),ipH_min(20000),numaa(20000),
     1			hQr(20,50),hpI(3,20,50),hGmin(20,50),
     2			hpHmin(20,50), hGlim1(20,50),hGlim2(20,50),
     3			hGminN(20,50),hGlim1N(20,50),hGlim2N(20,50),
     4			loc_ind (20000),nloc(20),Sh(50),SNh(50)
	REAL		Sdiff(20000), SdiffN(20000)
	REAL		Gsums (51,12,2), tmp_norm (12)
	INTEGER		Sdiffh(50), SdiffNh(50)
	CHARACTER*80	rec, line_here
	CHARACTER*60	over_100, pdb_only, localise, scf_process,
     1			make_list, ufiles
	CHARACTER*20	nameloc(20)
	CHARACTER*11	pHmin_flag(20000)
	CHARACTER*5	pdbC,pdbCid(20000)
	CHARACTER*4	pdb,pdbid(20000),atyp
	CHARACTER*1	skip
	LOGICAL		bigger_ones, pdbonly, cell_loc, scf, pH_list,
     1			open_unfolded

1200	FORMAT (A4)
1220	FORMAT (A5)
1240	FORMAT (6X,I2)
1300	FORMAT (A80)
1340	FORMAT (I4)
1400	FORMAT (F5.1,I4,F11.3)
1500	FORMAT (F5.1,15X,F11.3,35X,F6.1)
1600	FORMAT (I5)
1700	FORMAT (F6.2)
2100	FORMAT (4X,'Qratio pI(N) pI(U) delpI pHatGmin Gmin',
     1		      '   G(-5)  G(20) GminN GN(-5) GN(20)')
2200	FORMAT ('mins  ',F4.2,1X,F5.2,1X,F5.2,1X,F5.2,2X,F5.1,1X,F6.1,
     1			      1X,F6.1,1X,F6.1,1X,F6.2,1X,F6.2,1X,F6.2)
2300	FORMAT ('maxs  ',F4.2,1X,F5.2,1X,F5.2,1X,F5.2,2X,F5.1,1X,F6.1,
     1			      1X,F6.1,1X,F6.1,1X,F6.2,1X,F6.2,1X,F6.2)
2400	FORMAT ('bins  ',F4.2,1X,F5.2,1X,F5.2,1X,F5.2,2X,F5.1,1X,F6.1,
     1			      1X,F6.1,1X,F6.1,1X,F6.2,1X,F6.2,1X,F6.2)
2500	FORMAT (6X,I4,2X,I4,2X,I4,2X,I4,3X,I4,3X,I4,3X,I4,3X,I4,
     1				  3X,I4,3X,I4,3X,I4)
2550	FORMAT (I2,4X,I4,2X,I4,2X,I4,2X,I4,3X,I4,3X,I4,3X,I4,3X,I4,
     1				  3X,I4,3X,I4,3X,I4)
2600	FORMAT ('Data below for: ',A20,1X,I2,' with ',I4,' pdbs')
3100	FORMAT (' ',F6.2,1X,F8.2,9X,F8.2)
3020	FORMAT (' ',42X,3(F10.3,2X))
4100	FORMAT (11X,'Stotal    StotalN     Sdiff    SdiffN (R units)')
4200	FORMAT ('mins  ',4(1X,F10.4))
4300	FORMAT ('maxs  ',4(1X,F10.4))
4400	FORMAT ('bins  ',4(1X,F10.4))
4500	FORMAT (6X,4(1X,I10))
4580	FORMAT ('ih',9X,'Stotal    StotalN     Sdiff    SdiffN',
     1' (R units)')
4600	FORMAT (I2,4X,4(1X,I10))
4800	FORMAT (/,'ES',/,' pdb ',' Qratio  pI(N)  pI(U)  delpI  pHat',
     1		'Gmin  Gmin   G(-5)   G(20)   GminN  GN(-5)  GN(20)',
     2          ' pHatGmin_int flag     Q_pH_7.0')
4820	FORMAT (A4,'   ',F5.3,1X,F6.3,1X,F6.3,1X,F6.3,2X,F6.2,1X,F7.2,
     1		1X,F7.2,1X,F7.2,1X,F7.3,1X,F7.3,1X,F7.3,2X,F6.2,2X,A11,
     2		2X,F7.2)
4830	FORMAT (A5,'  ', F5.3,1X,F6.3,1X,F6.3,1X,F6.3,2X,F6.2,1X,F7.2,
     1		1X,F7.2,1X,F7.2,1X,F7.3,1X,F7.3,1X,F7.3,2X,F6.2,2X,A11,
     2		2X,F7.2)
4900	FORMAT (/,'SCF',/,' pdb ',6X,'Stotal    StotalN     Sdiff    ',
     1'SdiffN (R units)')
4920	FORMAT (A4,2X,4(1X,F10.4))
4930	FORMAT (A5,1X,4(1X,F10.4))
5050	FORMAT ('   pH  ',12(3X,I2,3X))
5100	FORMAT (F7.2,12(1X,F7.2))
5150	FORMAT (F7.2,12(1X,F7.3))
5200	FORMAT (2X,I2,2X,A20)

	CALL	names_init (nameloc)

	CALL	GETENV ('PDB_ONLY', pdb_only)
	CALL	leader (pdb_only, ipo)
	pdbonly		= .FALSE.
	IF (pdb_only(1:3).EQ.'yes') pdbonly = .TRUE.

	CALL	GETENV ('OVER_100', over_100)
	CALL	leader (over_100, ioo)
	bigger_ones	= .FALSE.
	IF (over_100(1:3).EQ.'yes') bigger_ones = .TRUE.

	CALL	GETENV ('LOCALISE', localise)
	CALL	leader (localise, iloc)
	cell_loc	= .FALSE.
	IF (localise(1:3).EQ.'yes') cell_loc = .TRUE.

	CALL	GETENV ('SCF_PROCESS', scf_process)
	CALL	leader (scf_process, isp)
	scf		= .FALSE.
	IF (scf_process(1:3).EQ.'yes') scf = .TRUE.

	CALL	GETENV ('PH_LIST', make_list)
	CALL	leader (make_list, iml)
	pH_list		= .FALSE.
	IF (make_list(1:3).EQ.'yes') pH_list = .TRUE.

	CALL	GETENV ('UFILES', ufiles)
	CALL	leader (ufiles, iuf)
	open_unfolded	= .FALSE.
	IF (ufiles(1:3).EQ.'yes') open_unfolded = .TRUE.

C Open a file to hold two records per pdb, one es and one scf information.

	OPEN(UNIT=4, NAME='combo_scan.txt', TYPE='NEW')
	WRITE (4,4800)

C Assume that we have 51 pH pts.

	npH		= 51

C AND (May 2009) assume we have 12 subc locations - zero the sums.

	IF (pH_list .AND. cell_loc) THEN
	  DO 170 m		= 1, 51
	    DO 170 n		= 1, 12
	      Gsums (m,n,1)	= 0.
	      Gsums (m,n,2)	= 0.
170	  CONTINUE						! End n,m
	END IF

	OPEN (UNIT=1, NAME='DHpdb_scan.list', TYPE='OLD')
	npdb		= 0
200	npdb		= npdb + 1
	IF (npdb .GT. 20000) STOP 'npdb > 20000'
	READ (1,1300,END=210) rec
	IF (pdbonly) THEN
	  READ (rec,1200) pdb
	  skip		= pdb(1:1)
	ELSE
	  READ (rec,1220) pdbC
	  skip		= pdbC(1:1)
	END IF
	IF (skip .EQ. '#') THEN
	  npdb		= npdb - 1
	  GOTO 200
	ELSE
	  IF (pdbonly) THEN
	    pdbid (npdb)	= pdb
	  ELSE
	    pdbCid (npdb)	= pdbC
	  END IF
	  IF (cell_loc) THEN
	    READ (rec,1240) loc_ind (npdb)
	    IF ((loc_ind(npdb).LT.1).OR.(loc_ind(npdb).GT.12))
     1		 STOP 'cell loc oub'
	  END IF
	END IF

	IF (open_unfolded) THEN
	  IF (pdbonly) THEN
	    OPEN (UNIT=2,NAME=pdb//'_Ues.pdb',TYPE='OLD')
	  ELSE
	    OPEN (UNIT=2,NAME=pdbC//'_Ues.pdb',TYPE='OLD')
	  END IF
	ELSE
	  IF (pdbonly) THEN
	    OPEN (UNIT=2,NAME=pdb//'_Fes.pdb',TYPE='OLD')
	  ELSE
	    OPEN (UNIT=2,NAME=pdbC//'_Fes.pdb',TYPE='OLD')
	  END IF
	END IF
	nres_last	= -999
	naa		= 0
204	READ (2,1300,END=206) rec
	IF (rec(1:4).EQ.'ATOM') THEN
	  READ (rec(14:17),1200) atyp
	  IF ((atyp.EQ.'NT  ') .OR.
     1	      (atyp.EQ.'CT  ') .OR.
     2	      (atyp.EQ.'OT1 ') .OR.
     3	      (atyp.EQ.'OT2 ')) GOTO 204
	  READ (rec(23:26),1340) nres
	  IF (nres .NE. nres_last) naa = naa + 1
	  nres_last	= nres
	END IF
	GOTO 204

206	numaa(npdb)	= naa
	IF (bigger_ones .AND. (naa.LT.100)) THEN
	   npdb		= npdb - 1
	  CLOSE (UNIT=2)
	  GOTO 200
	END IF
	IF (pdbonly) THEN
	  WRITE (6,*) 'processing ',pdb,' with ',naa,' aas'
	ELSE
	  WRITE (6,*) 'processing ',pdbC,' with ',naa,' aas'
	END IF
	CLOSE (UNIT=2)
	GOTO 200

210	CLOSE (UNIT=1)
	npdb		= npdb - 1
	WRITE (6,*) 'processing ', npdb, ' molecules'

	DO 320 ipdb	= 1, npdb

	  IF (pdbonly) THEN
	    pdb		= pdbid (ipdb)
	  ELSE
	    pdbC	= pdbCid (ipdb)
	  END IF
	  ngps(ipdb)	= 0
	  pI(1,ipdb)	= 0.
	  pI(2,ipdb)	= 0.

	  IF (open_unfolded) THEN
	    IF (pdbonly) THEN
	      OPEN (UNIT=2,NAME='pkU_'//pdb//'_DHrs.out',TYPE='OLD')
	    ELSE
	      OPEN (UNIT=2,NAME='pkU_'//pdbC//'_DHrs.out',TYPE='OLD')
	    END IF
	  ELSE
	    IF (pdbonly) THEN
	      OPEN (UNIT=2,NAME='pkF_'//pdb//'_DHrs.out',TYPE='OLD')
	    ELSE
	      OPEN (UNIT=2,NAME='pkF_'//pdbC//'_DHrs.out',TYPE='OLD')
	    END IF
	  END IF
230	  READ (2,1300,END=250) rec
	  IF (rec (1:11) .EQ. '  pH  n_red') THEN
	    READ (2,*)
	    READ (2,1300) rec
	    READ (rec(1:20),1400) pH, n_red, G_by_Z
	    IF ((pH.NE.-5.0).OR.(n_red.GT.15)) STOP 'pH/nred val prob'
C??	    IF ((pH.NE.-5.0).OR.(n_red.NE.0)) STOP 'pH/nred val prob'
	    rs_en_kT (ipdb)	= G_by_Z
	    GOTO 260
	  END IF
	  GOTO 230

250	  STOP 'pH  nred not found'

260	  CLOSE (UNIT=2)
	  IF (open_unfolded) THEN
	    IF (pdbonly) THEN
	      OPEN (UNIT=2,NAME='pkU_'//pdb//'_DHmc.out',TYPE='OLD')
	    ELSE
	      OPEN (UNIT=2,NAME='pkU_'//pdbC//'_DHmc.out',TYPE='OLD')
	    END IF
	  ELSE
	    IF (pdbonly) THEN
	      OPEN (UNIT=2,NAME='pkF_'//pdb//'_DHmc.out',TYPE='OLD')
	    ELSE
	      OPEN (UNIT=2,NAME='pkF_'//pdbC//'_DHmc.out',TYPE='OLD')
	    END IF
	  END IF
270	  READ (2,1300,END=300) rec
	  IF      (rec(1:11) .EQ. '  pH       ') THEN
	    READ (2,*)
	    DO 280 ipH		= 1, npH
C??Feb08	      READ (2,1500) pH, G_by_Q
	      READ (2,1500) pH, G_by_Q, Qnet (ipdb,ipH)
	      IF ((pH.NE.-5.0+0.5*FLOAT(ipH-1))) STOP 'pH val prob'
	      mc_en_kT(ipH,ipdb)	= G_by_Q
280	    CONTINUE						! End ipH
	  ELSE IF (rec(1:12).EQ.'which should') THEN
	    READ (rec(21:25),1600) ngps(ipdb)
	  ELSE IF (rec (1:14).EQ.'folded protein') THEN
	    READ (rec(24:29),1700) pI(1,ipdb)
	  ELSE IF (rec (1:15).EQ.'iso amino acids') THEN
	    READ (rec(24:29),1700) pI(2,ipdb)
	  END IF
	  GOTO 270

300	  CLOSE (UNIT=2)
	  IF (ngps(ipdb) .EQ. 0) STOP 'ngps unfound'
	  IF (pI(1,ipdb) .EQ. 0.) THEN
	    WRITE (6,*) 'problem at ',pdbC
	    STOP 'folded pI unfound'
	  END IF
	  IF (pI(2,ipdb) .EQ. 0.) STOP 'iso aas pI unfound'

320	CONTINUE						! End ipdb

	delpI_min_all		= 999.
	delpI_max_all		= 0.
	delpI_max_acid		= 0.
	FpI_min			= 999.
	FpI_max			= 0.
	UpI_min			= 999.
	UpI_max			= 0.
	G_min_min		= 999.
	G_min_max		= -999.
	G_lim1_min		= 999.
	G_lim1_max		= -999.
	G_lim2_min		= 999.
	G_lim2_max		= -999.

	G_minN_min		= 999.
	G_minN_max		= -999.
	G_lim1N_min		= 999.
	G_lim1N_max		= -999.
	G_lim2N_min		= 999.
	G_lim2N_max		= -999.

C First, get the limits - use global lims even if we're splitting by cell_loc,
C since then all histograms will be directly comparable.
C Mar 05 update to o/p an x,y text file of pH, rs-adjusted energy in
C separate files for each pdb.

	DO 400 ipdb		= 1, npdb
	  IF (pdbonly) THEN
	    pdb		= pdbid (ipdb)
	  ELSE
	    pdbC	= pdbCid (ipdb)
	  END IF
	  delpI			= pI(1,ipdb) - pI(2,ipdb)
	  pI(3,ipdb)		= delpI
	  IF (delpI .LT. delpI_min_all) delpI_min_all = delpI
	  IF (delpI .GT. delpI_max_all) delpI_max_all = delpI
	  IF (pI(1,ipdb) .LT. FpI_min) FpI_min = pI(1,ipdb)
	  IF (pI(1,ipdb) .GT. FpI_max) FpI_max = pI(1,ipdb)
	  IF (pI(2,ipdb) .LT. UpI_min) UpI_min = pI(2,ipdb)
	  IF (pI(2,ipdb) .GT. UpI_max) UpI_max = pI(2,ipdb)
	  IF (delpI .LT. delpI_min_all) delpI_min_all = delpI
	  IF (delpI .GT. delpI_max_all) delpI_max_all = delpI
	  IF (pI(2,ipdb) .LT. 6.) THEN
	    IF (delpI.GT.delpI_max_acid) delpI_max_acid = delpI
	  END IF
	  IF (pH_list) THEN
	    IF (pdbonly) THEN
	      OPEN (UNIT=3, NAME=pdb//'_GvspH.txt', TYPE='NEW')
	    ELSE
	      OPEN (UNIT=3, NAME=pdbC//'_GvspH.txt', TYPE='NEW')
	    END IF
	  END IF
	  IF (pH_list) THEN
	    WRITE (3,*) '   pH  G(ionis) kJ/mole G(ionis)_N'
	  END IF
	  Gmin_here		= 999.
	  QnetpH7(ipdb)		= 999.
	  DO 360 ipH		= 1, npH
	    en(ipH,ipdb)	= 2.5*(mc_en_kT(ipH,ipdb)+
     1				       rs_en_kT(ipdb))
	    enN(ipH,ipdb)	= en(ipH,ipdb)/FLOAT(numaa(ipdb))
	    IF (en(ipH,ipdb).LT.Gmin_here) THEN
	      Gmin_here = en(ipH,ipdb)
	      GminN_here = enN(ipH,ipdb)
	      ipHmin_here	= ipH
	      pHminX(ipdb)	= -5.0 + FLOAT(ipH-1)*0.5
	    END IF
	      pH_here		= -5.0 + FLOAT(ipH-1)*0.5
	      IF (ABS(pH_here-7.0) .LT. 0.001) THEN
	        QnetpH7(ipdb)	= Qnet(ipdb,ipH)
	      END IF
	      IF (pH_list) THEN
	        WRITE (3,3100) pH_here, en(ipH,ipdb), enN(ipH,ipdb)
	        IF (cell_loc) THEN
		  loc_here		= loc_ind (ipdb)
	          Gsums(ipH,loc_here,1)	= Gsums(ipH,loc_here,1) +
     1					  en(ipH,ipdb)
	          Gsums(ipH,loc_here,2)	= Gsums(ipH,loc_here,2) +
     1					  enN(ipH,ipdb)
	        END IF
	      END IF
Cerror??    END IF
360	  CONTINUE						! End ipH
	  IF (QnetpH7(ipdb) .EQ. 999.) STOP 'Net Q at pH 7.0 unfound'
	  IF (pH_list) CLOSE (UNIT=3)
	  G_min (ipdb)		= Gmin_here
	  G_minN (ipdb)		= GminN_here
	  ipH_min (ipdb)	= ipHmin_here

C Added Nov 2008 to get a second pH_atGmin - from interpolation.
C Try 5 point interpolation, and then 3 point if the 5 point fails.

	  IF ((ipHmin_here.GE.3).AND.(ipHmin_here.LE.(npH-2))) THEN
	    x1			= pHminX(ipdb) - 1.0
	    x2			= pHminX(ipdb) - 0.5
	    x4			= pHminX(ipdb) + 0.5
	    x5			= pHminX(ipdb) + 1.0
	    y1			= en(ipHmin_here-2,ipdb)
	    y2			= en(ipHmin_here-1,ipdb)
	    y4			= en(ipHmin_here+1,ipdb)
	    y5			= en(ipHmin_here+2,ipdb)
	    FmA			= (y2-y1)/(x2-x1)
	    FmB			= (y4-y5)/(x4-x5)
	    xI			= (FmB*x5-FmA*x1+y1-y5)/(FmB-FmA)
	    pHmin_interp (ipdb)	= xI
	  ELSE
	    pHmin_interp (ipdb)	= pHminX (ipdb)
	  END IF
	  IF (ABS(pHmin_interp(ipdb) - pHminX(ipdb)) .GT. 0.5) THEN
	    IF ((ipHmin_here.GE.2).AND.(ipHmin_here.LE.(npH-1))) THEN
	      x1		= pHminX(ipdb) - 0.5
	      x2		= pHminX(ipdb)
	      x3		= pHminX(ipdb) + 0.5
	      y1		= en(ipHmin_here-1,ipdb)
	      y2		= en(ipHmin_here,ipdb)
	      y3		= en(ipHmin_here+1,ipdb)
	      d32		= ABS (y3 - y2)
	      d21		= ABS (y2 - y1)
	      wt		= d32 / (d32 + d21)
	      xI		= x1 + wt*(x3 - x1)
	      pHmin_interp (ipdb) = xI
	    END IF
	    pHmin_flag(ipdb)	= '3_pt_interp'
	  ELSE
	    pHmin_flag(ipdb)	= '5_pt_interp'
	  END IF
	  IF (ABS(pHmin_interp(ipdb) - pHminX(ipdb)) .GT. 0.5) THEN
	    pHmin_flag(ipdb)	= 'INTERP FAIL'
	  END IF

	  IF (Gmin_here.LT.G_min_min) G_min_min = Gmin_here
	  IF (Gmin_here.GT.G_min_max) G_min_max = Gmin_here
	  IF (en(1,ipdb).LT.G_lim1_min) G_lim1_min = en(1,ipdb)
	  IF (en(1,ipdb).GT.G_lim1_max) G_lim1_max = en(1,ipdb)
	  IF (en(npH,ipdb).LT.G_lim2_min) G_lim2_min=en(npH,ipdb)
	  IF (en(npH,ipdb).GT.G_lim2_max) G_lim2_max=en(npH,ipdb)

	  IF (GminN_here.LT.G_minN_min) G_minN_min = GminN_here
	  IF (GminN_here.GT.G_minN_max) G_minN_max = GminN_here
	  IF (enN(1,ipdb).LT.G_lim1N_min) G_lim1N_min = enN(1,ipdb)
	  IF (enN(1,ipdb).GT.G_lim1N_max) G_lim1N_max = enN(1,ipdb)
	IF (enN(npH,ipdb).LT.G_lim2N_min) G_lim2N_min=enN(npH,ipdb)
	IF (enN(npH,ipdb).GT.G_lim2N_max) G_lim2N_max=enN(npH,ipdb)

400	CONTINUE						! End ipdb

C Second, get the frequency histograms.

	Qr_min			= 0.0
	Qr_max			= 0.5
	Qr_bin			= 0.01
	delpI_range		= delpI_max_all-delpI_min_all
	delpI_bin		= delpI_range/50.
	FpI_range		= FpI_max-FpI_min
	FpI_bin			= FpI_range/50.
	UpI_range		= UpI_max-UpI_min
	UpI_bin			= UpI_range/50.
	G_min_range		= G_min_max-G_min_min
	G_min_bin		= G_min_range/50.
	pH_min			= -5.0
	pH_max			= 19.5
	pH_bin			= 0.5
	G_lim1_range		= G_lim1_max-G_lim1_min
	G_lim1_bin		= G_lim1_range/50.
	G_lim2_range		= G_lim2_max-G_lim2_min
	G_lim2_bin		= G_lim2_range/50.

	G_minN_range		= G_minN_max-G_minN_min
	G_minN_bin		= G_minN_range/50.
	G_lim1N_range		= G_lim1N_max-G_lim1N_min
	G_lim1N_bin		= G_lim1N_range/50.
	G_lim2N_range		= G_lim2N_max-G_lim2N_min
	G_lim2N_bin		= G_lim2N_range/50.

	DO 480 ih		= 1, 50
	  DO 480 mloc		= 1, 20
	    hQr(mloc,ih)	= 0
	    hpI(1,mloc,ih)	= 0
	    hpI(2,mloc,ih)	= 0
	    hpI(3,mloc,ih)	= 0
	    hGmin(mloc,ih)	= 0
	    hpHmin(mloc,ih)	= 0
	    hGlim1(mloc,ih)	= 0
	    hGlim2(mloc,ih)	= 0

	    hGminN(mloc,ih)	= 0
	    hGlim1N(mloc,ih)	= 0
	    hGlim2N(mloc,ih)	= 0
480	CONTINUE						! End mloc,ih
	DO 490 mloc		= 1, 20
	  nloc(mloc)		= 0
490	CONTINUE						! End mloc

	DO 500 ipdb		= 1, npdb

	  IF (cell_loc) THEN
	    mloc		= loc_ind(ipdb)
	    nloc(mloc)		= 1 + nloc(mloc)
	  END IF
	  naa			= numaa(ipdb)
	  ratio			= FLOAT(ngps(ipdb))/FLOAT(naa)
	  Qratio(ipdb)		= ratio

	  i			= ipdb
	  IF (pdbonly) THEN
	    WRITE (4,4820) pdbid(i),Qratio(i),pI(1,i),pI(2,i),
     1			   pI(3,i),pHminX(i),G_min(i),en(1,i),
     2			   en(npH,i),G_minN(i),enN(1,i),enN(npH,i),
     3                     pHmin_interp(i),pHmin_flag(i),QnetpH7(i)
	  ELSE
	    WRITE (4,4830) pdbCid(i),Qratio(i),pI(1,i),pI(2,i),
     1			   pI(3,i),pHminX(i),G_min(i),en(1,i),
     2			   en(npH,i),G_minN(i),enN(1,i),enN(npH,i),
     3                     pHmin_interp(i),pHmin_flag(i),QnetpH7(i)
	  END IF

	  IF (ratio.GE.0.50) THEN
	    hQr(20,50)		= 1 + hQr(20,50)
	    IF (cell_loc) hQr(mloc,50) = 1 + hQr(mloc,50)
	  ELSE
	    ih			= 1 + INT(ratio/0.01)
	    hQr(20,ih)		= 1 + hQr(20,ih)
	    IF (cell_loc) hQr(mloc,ih) = 1 + hQr(mloc,ih)
	  END IF

	  ih			= 1 + INT((pI(3,ipdb)-
     1					   delpI_min_all)/delpI_bin)
	  IF (ih.LT.1) ih	= 1
	  IF (ih.GT.50) ih	= 50
	  hpI(3,20,ih)		= 1 + hpI(3,20,ih)
	  IF (cell_loc) hpI(3,mloc,ih) = 1 + hpI(3,mloc,ih)

	  ih			= 1 + INT((pI(1,ipdb)-
     1					   FpI_min)/FpI_bin)
	  IF (ih.LT.1) ih	= 1
	  IF (ih.GT.50) ih	= 50
	  hpI(1,20,ih)		= 1 + hpI(1,20,ih)
	  IF (cell_loc) hpI(1,mloc,ih) = 1 + hpI(1,mloc,ih)

	  ih			= 1 + INT((pI(2,ipdb)-
     1					   UpI_min)/UpI_bin)
	  IF (ih.LT.1) ih	= 1
	  IF (ih.GT.50) ih	= 50
	  hpI(2,20,ih)		= 1 + hpI(2,20,ih)
	  IF (cell_loc) hpI(2,mloc,ih) = 1 + hpI(2,mloc,ih)

	  ih			= 1 + INT((G_min(ipdb)-
     1					   G_min_min)/G_min_bin)
	  IF (ih.LT.1) ih	= 1
	  IF (ih.GT.50) ih	= 50
	  hGmin(20,ih)		= 1 + hGmin(20,ih)
	  IF (cell_loc) hGmin(mloc,ih) = 1 + hGmin(mloc,ih)

	  ih			= ipH_min(ipdb)
	  hpHmin(20,ih)		= 1 + hpHmin(20,ih)
	  IF (cell_loc) hpHmin(mloc,ih) = 1 + hpHmin(mloc,ih)

	  ih			= 1 + INT((en(1,ipdb)-
     1					   G_lim1_min)/G_lim1_bin)
	  IF (ih.LT.1) ih	= 1
	  IF (ih.GT.50) ih	= 50
	  hGlim1(20,ih)		= 1 + hGlim1(20,ih)
	  IF (cell_loc) hGlim1(mloc,ih) = 1 + hGlim1(mloc,ih)

	  ih			= 1 + INT((en(npH,ipdb)-
     1					   G_lim2_min)/G_lim2_bin)
	  IF (ih.LT.1) ih	= 1
	  IF (ih.GT.50) ih	= 50
	  hGlim2(20,ih)		= 1 + hGlim2(20,ih)
	  IF (cell_loc) hGlim2(mloc,ih) = 1 + hGlim2(mloc,ih)

	  ih			= 1 + INT((G_minN(ipdb)-
     1					   G_minN_min)/G_minN_bin)
	  IF (ih.LT.1) ih	= 1
	  IF (ih.GT.50) ih	= 50
	  hGminN(20,ih)		= 1 + hGminN(20,ih)
	  IF (cell_loc) hGminN(mloc,ih) = 1 + hGminN(mloc,ih)

	  ih			= 1 + INT((enN(1,ipdb)-
     1					   G_lim1N_min)/G_lim1N_bin)
	  IF (ih.LT.1) ih	= 1
	  IF (ih.GT.50) ih	= 50
	  hGlim1N(20,ih)	= 1 + hGlim1N(20,ih)
	  IF (cell_loc) hGlim1N(mloc,ih) = 1 + hGlim1N(mloc,ih)

	  ih			= 1 + INT((enN(npH,ipdb)-
     1					   G_lim2N_min)/G_lim2N_bin)
	  IF (ih.LT.1) ih	= 1
	  IF (ih.GT.50) ih	= 50
	  hGlim2N(20,ih)	= 1 + hGlim2N(20,ih)
	  IF (cell_loc) hGlim2N(mloc,ih) = 1 + hGlim2N(mloc,ih)

500	CONTINUE						! End ipdb

	WRITE (6,*) 'SUM OVER ALL PDBs/CELL LOCALISATIONS'
	WRITE (6,*)
	WRITE (6,2100)
	WRITE (6,*)
	WRITE (6,2200) Qr_min,FpI_min,UpI_min,delpI_min_all,
     1		       pH_min,G_min_min,
     2		       G_lim1_min,G_lim2_min,G_minN_min,
     3		       G_lim1N_min,G_lim2N_min
	WRITE (6,2300) Qr_max,FpI_max,UpI_max,delpI_max_all,
     1		       pH_max,G_min_max,
     2		       G_lim1_max,G_lim2_max,G_minN_max,
     3		       G_lim1N_max,G_lim2N_max
	WRITE (6,2400) Qr_bin,FpI_bin,UpI_bin,delpI_bin,
     1		       pH_bin,G_min_bin,
     2		       G_lim1_bin,G_lim2_bin,G_minN_bin,
     3		       G_lim1N_bin,G_lim2N_bin
	WRITE (6,*)
	DO 540 ih		= 1, 50
	  WRITE (6,2500) hQr(20,ih),hpI(1,20,ih),hpI(2,20,ih),
     1			 hpI(3,20,ih),hpHmin(20,ih),
     2			 hGmin(20,ih),hGlim1(20,ih),
     3			 hGlim2(20,ih),hGminN(20,ih),
     4			 hGlim1N(20,ih),hGlim2N(20,ih)
540	CONTINUE						! End ih

	WRITE (6,*)
	WRITE (6,*) 'Next: Cumulative es distributions'
	WRITE (6,*)
	iQr		= 0
	ipI1		= 0
	ipI2		= 0
	ipI3		= 0
	ipHmin		= 0
	iGmin		= 0
	iGlim1		= 0
	iGlim2		= 0
	iGminN		= 0
	iGlim1N		= 0
	iGlim2N		= 0
	DO 560 ih	= 1, 50
	  iQr		= iQr + hQr(20,ih)
	  ipI1		= ipI1 + hpI(1,20,ih)
	  ipI2		= ipI2 + hpI(2,20,ih)
	  ipI3		= ipI3 + hpI(3,20,ih)
	  ipHmin	= ipHmin + hpHmin(20,ih)
	  iGmin		= iGmin + hGmin(20,ih)
	  iGlim1	= iGlim1 + hGlim1(20,ih)
	  iGlim2	= iGlim2 + hGlim2(20,ih)
	  iGminN	= iGminN + hGminN(20,ih)
	  iGlim1N	= iGlim1N + hGlim1N(20,ih)
	  iGlim2N	= iGlim2N + hGlim2N(20,ih)
	  WRITE (6,2550) ih, iQr,ipI1,ipI2,
     1			 ipI3,ipHmin,
     2			 iGmin,iGlim1,
     3			 iGlim2,iGminN,
     4			 iGlim1N,iGlim2N
560	CONTINUE						! End ih

	IF (cell_loc) THEN

	DO 600 mloc		= 1, 12
	WRITE (6,*)
	WRITE (6,2600) nameloc(mloc),mloc,nloc(mloc)
	WRITE (6,*)
	WRITE (6,2100)
	WRITE (6,*)
	WRITE (6,2200) Qr_min,FpI_min,UpI_min,delpI_min_all,
     1		       pH_min,G_min_min,
     2		       G_lim1_min,G_lim2_min,G_minN_min,
     3		       G_lim1N_min,G_lim2N_min
	WRITE (6,2300) Qr_max,FpI_max,UpI_max,delpI_max_all,
     1		       pH_max,G_min_max,
     2		       G_lim1_max,G_lim2_max,G_minN_max,
     3		       G_lim1N_max,G_lim2N_max
	WRITE (6,2400) Qr_bin,FpI_bin,UpI_bin,delpI_bin,
     1		       pH_bin,G_min_bin,
     2		       G_lim1_bin,G_lim2_bin,G_minN_bin,
     3		       G_lim1N_bin,G_lim2N_bin
	WRITE (6,*)
	DO 580 ih		= 1, 50
	  WRITE (6,2500) hQr(mloc,ih),hpI(1,mloc,ih),hpI(2,mloc,ih),
     1			 hpI(3,mloc,ih),hpHmin(mloc,ih),
     2			 hGmin(mloc,ih),hGlim1(mloc,ih),
     3			 hGlim2(mloc,ih),hGminN(mloc,ih),
     4			 hGlim1N(mloc,ih),hGlim2N(mloc,ih)
580	CONTINUE						! End ih
600	CONTINUE						! End mloc

	END IF

C Add in the scf gear after the Ges(pH) processing (March 06).
C Add in differential free form (which includes expt rot) to folded (with).

	IF (scf) THEN

	  WRITE (4,4900)

	  Smin			=  99999.
	  Smax			= -99999.
	  SNmin			=  99999.
	  SNmax			= -99999.
	  Sdiffmin		=  99999.
	  Sdiffmax		= -99999.
	  SdiffNmin		=  99999.
	  SdiffNmax		= -99999.
	  DO 650 ipdb		= 1, npdb
	    IF (pdbonly) THEN
	      pdb		= pdbid (ipdb)
	      OPEN (UNIT=2,NAME='scf_'//pdb//'.out',TYPE='OLD')
	    ELSE
	      pdbC	= pdbCid (ipdb)
	      OPEN (UNIT=2,NAME='scf_'//pdbC//'.out',TYPE='OLD')
	    END IF

620	    READ (2,1300,END=630) line_here
	    IF (line_here(3:5) .EQ. "tot") THEN
	      READ (line_here,3020) Sfree, Swith, Swithout
	      S(ipdb)		= Swithout
	      IF (Swithout .LT. Smin) Smin = Swithout
	      IF (Swithout .GT. Smax) Smax = Swithout
	      SN(ipdb)	= Swithout/FLOAT(numaa(ipdb))
	      IF (SN(ipdb) .LT. SNmin) SNmin = SN(ipdb)
	      IF (SN(ipdb) .GT. SNmax) SNmax = SN(ipdb)
	      Sdiff(ipdb)	= Sfree - Swith
	      IF (Sdiff(ipdb).LT.Sdiffmin) Sdiffmin = Sdiff(ipdb)
	      IF (Sdiff(ipdb).GT.Sdiffmax) Sdiffmax = Sdiff(ipdb)
	      SdiffN(ipdb)	= Sdiff(ipdb)/FLOAT(numaa(ipdb))
	      IF (SdiffN(ipdb).LT.SdiffNmin) SdiffNmin = SdiffN(ipdb)
	      IF (SdiffN(ipdb).GT.SdiffNmax) SdiffNmax = SdiffN(ipdb)
	      GOTO 640
	    END IF
	    GOTO 620

630	    STOP 'totals line not found in scf output'

640	    CLOSE (UNIT=2)
650	  CONTINUE						! End ipdb

	  DO 660 ih		= 1, 50
	    Sh(ih)		= 0
	    SNh(ih)		= 0
	    Sdiffh(ih)		= 0
	    SdiffNh(ih)		= 0
660	  CONTINUE						! End ih
	  Srange		= Smax - Smin
	  Sbin			= Srange/50.
	  SNrange		= SNmax - SNmin
	  SNbin			= SNrange/50.
	  Sdiffrange		= Sdiffmax - Sdiffmin
	  Sdiffbin		= Sdiffrange/50.
	  SdiffNrange		= SdiffNmax - SdiffNmin
	  SdiffNbin		= SdiffNrange/50.
	  DO 680 ipdb		= 1, npdb

	    i			= ipdb
	    IF (pdbonly) THEN
	      WRITE (4,4920) pdbid(i),S(i),SN(i),Sdiff(i),SdiffN(i)
	    ELSE
	      WRITE (4,4930) pdbCid(i),S(i),SN(i),Sdiff(i),SdiffN(i)
	    END IF

	    ih			= 1 + INT((S(ipdb)-Smin)/Sbin)
	    IF (ih.LT.1) ih	= 1
	    IF (ih.GT.50) ih	= 50
	    Sh(ih)		= 1 + Sh(ih)
	    ih			= 1 + INT((SN(ipdb)-SNmin)/SNbin)
	    IF (ih.LT.1) ih	= 1
	    IF (ih.GT.50) ih	= 50
	    SNh(ih)		= 1 + SNh(ih)
	ih		 = 1 + INT((Sdiff(ipdb)-Sdiffmin)/Sdiffbin)
	IF (ih.LT.1) ih	 = 1
	IF (ih.GT.50) ih = 50
	Sdiffh(ih)	 = 1 + Sdiffh(ih)
	ih		 = 1 + INT((SdiffN(ipdb)-SdiffNmin)/SdiffNbin)
	IF (ih.LT.1) ih	 = 1
	IF (ih.GT.50) ih = 50
	SdiffNh(ih)	 = 1 + SdiffNh(ih)
680	  CONTINUE						! End ipdb
	  WRITE (6,*)
	  WRITE (6,*) 'SCF data (if requested with SCF_PROCESS="yes")'
	  WRITE (6,*)
	  WRITE (6,4100)
	  WRITE (6,*)
	  WRITE (6,4200) Smin, SNmin, Sdiffmin, SdiffNmin
	  WRITE (6,4300) Smax, SNmax, Sdiffmax, SdiffNmax
	  WRITE (6,4400) Sbin, SNbin, Sdiffbin, SdiffNbin
	  WRITE (6,*)
	  DO 700 ih		= 1, 50
	    WRITE (6,4500) Sh(ih),SNh(ih),Sdiffh(ih),SdiffNh(ih)
700	  CONTINUE						! End ih
	  WRITE (6,*)
	  WRITE (6,*) 'Next: Cumulative SCF distributions'
	  WRITE (6,*)
	  WRITE (6,4580)
	  nSh			= 0
	  nSNh			= 0
	  nSdiffh		= 0
	  nSdiffNh		= 0
	  DO 720 ih		= 1, 50
	    nSh			= nSh + Sh(ih)
	    nSNh		= nSNh + SNh(ih)
	    nSdiffh		= nSdiffh + Sdiffh(ih)
	    nSdiffNh		= nSdiffNh + SdiffNh(ih)
	    WRITE (6,4600) ih,nSh,nSNh,nSdiffh,nSdiffNh
720	  CONTINUE						! End ih
	END IF

C ADDED MAY 2009 - get summed G vs pH for each subc location.

	IF (pH_list .AND. cell_loc) THEN
	  OPEN (UNIT=3, NAME='combo_GvspH.txt', TYPE='NEW')
	  WRITE (3,*)
	  WRITE (3,*) 'FIRST are the sums per protein - ALL kJ/mole'
	  WRITE (3,*)
	  WRITE (3,5050) (m,m=1,12)
	  DO 740 ipH		= 1, npH
	    pH_here		= -5.0 + FLOAT(ipH-1)*0.5
	    DO 736 m		= 1, 12
	      tmp_norm(m)	= Gsums(ipH,m,1)/FLOAT(nloc(m))
736	    CONTINUE						! End m
	    WRITE (3,5100) pH_here, (tmp_norm (m),m=1,12)
740	  CONTINUE						! End ipH
	  WRITE (3,*)
	  WRITE (3,*) 'SECOND are per protein and amino acid'
	  WRITE (3,*)
	  WRITE (3,5050) (m,m=1,12)
	  DO 750 ipH		= 1, npH
	    pH_here		= -5.0 + FLOAT(ipH-1)*0.5
	    DO 746 m		= 1, 12
	      tmp_norm(m)	= Gsums(ipH,m,2)/FLOAT(nloc(m))
746	    CONTINUE						! End m
	    WRITE (3,5150) pH_here, (tmp_norm (m),m=1,12)
750	  CONTINUE						! End ipH
	  WRITE (3,*)
	  DO 760 m		= 1, 12
	    WRITE (3,5200) m, nameloc (m)
760	  CONTINUE						! End m
	  CLOSE (UNIT=3)
	END IF

	CALL	EXIT
	END


	SUBROUTINE	names_init (nameloc)
C	**********	**********

	CHARACTER*20	nameloc (20)

	nameloc(1)	= 'nuclear             '
	nameloc(2)	= 'vacuolar            '
	nameloc(3)	= 'cytoplasmic         '
	nameloc(4)	= 'extracellular       '
	nameloc(5)	= 'lysosomal           '
	nameloc(6)	= 'chloroplast         '
	nameloc(7)	= 'mitochondrial       '
	nameloc(8)	= 'endoplasmic retic   '
	nameloc(9)	= 'peroxisomal         '
	nameloc(10)	= 'cytoskeletal        '
	nameloc(11)	= 'golgi               '
	nameloc(12)	= 'plasma membrane     '

	RETURN
	END


	SUBROUTINE	leader (char_array, itop)
C	**********	******

	CHARACTER*60	char_array

	itop	= 1
	DO WHILE (char_array (itop:itop) .NE. ' ')
	  itop	= itop + 1
	END DO
	itop	= itop - 1

	RETURN
	END

